import stackless as ss
from PySFML import sf
import graphics.graphics as graphics
import globals.globals as g
import channels.channels as channels
from . import channels as bgChannels
from settings.settings import *

layer = 1

numGround       = 10
groundOffsetX   = 0.0
groundWidth     = 104.0
groundY         = 595.0

mountainsFgY = 1024.0 - 256.0 * 2

mountainsBgY = 1024.0 - 256.0 * 2 - 30.0

def background2Tasklet():
    global layer

    backgroundImg = sf.Image()
    backgroundImg.LoadFromFile(dataPath + "backgrounds/clouds/clouds-bg.png")
    backgroundSpr = sf.Sprite(backgroundImg)

    cloudsImg = sf.Image()
    cloudsImg.LoadFromFile(dataPath + "backgrounds/clouds/clouds.png")
    cloudsSpr = sf.Sprite(cloudsImg)

    groundImg = sf.Image()
    groundImg.LoadFromFile(dataPath + "backgrounds/clouds/clouds-ground.png")
    groundSpr = sf.Sprite(groundImg)

    mountainsFgImg = sf.Image()
    mountainsFgImg.LoadFromFile(dataPath + "backgrounds/clouds/mtns-front.png")
    mountainsFgSpr = sf.Sprite(mountainsFgImg)

    mountainsBgImg = sf.Image()
    mountainsBgImg.LoadFromFile(dataPath + "backgrounds/clouds/mtns-back.png")
    mountainsBgSpr = sf.Sprite(mountainsBgImg)

    while 1:
        bgChannels.backgroundChannel.receive()

        # background
        backgroundSpr.SetPosition(0.0, 0.0)
        g.window.Draw(backgroundSpr)

        # clouds
        if layer >= 2:
            cloudsSpr.SetPosition(0.0, 0.0)
            g.window.Draw(cloudsSpr)

        # mountains (background)
        if layer >= 3:
            mountainsBgSpr.SetPosition(0.0, mountainsBgY)
            g.window.Draw(mountainsBgSpr)

        # mountains (foreground)
        if layer >= 4:
            mountainsFgSpr.SetPosition(0.0, mountainsFgY)
            g.window.Draw(mountainsFgSpr)

        # ground
        for i in range(numGround):
            groundSpr.SetPosition(groundOffsetX + groundWidth * i, groundY)
            g.window.Draw(groundSpr)

def backgroundUpdateTasklet():
    global layer

    while 1:
        layer = bgChannels.progressionChannel.receive()
        #print("layer: " + str(layer))
