import stackless as ss
from PySFML import sf
import channels.channels as channels
from . import channels as bgChannels
from . import enemy1
from . import enemy2
from . import enemy3

enemyTasklets = []
layer = 1

def gameMainTasklet():
    global enemyTasklets
    global layer

    layer = 1

    while 1:
        eventsList = channels.gameMainChannel.receive()

        bgChannels.worldChannel.send(None)
        bgChannels.backgroundChannel.send(None)

        channels.inputUpdateChannel.send(eventsList)

        # wait for game entities to finish updating for this frame
        while ss.getruncount() >= 2:
            #print("gameMain pre waiting...")
            ss.schedule()

        bgChannels.runCollisionsChannel.send(None)

        # wait for game entities to finish updating second time
        while ss.getruncount() >= 2:
            #print("gameMain post waiting... " + str(ss.getruncount()))
            ss.schedule()

def gameMainProgressionTasklet():
    global layer
    global enemyTasklets

    try:
        while 1:
            [t.kill() for t in enemyTasklets]

            if layer == 1:
                enemyTasklets = [ss.tasklet(enemy1.enemy1Tasklet)]
            elif layer == 2:
                enemyTasklets = [ss.tasklet(enemy2.enemy2Tasklet)]
            elif layer == 3:
                enemyTasklets = [ss.tasklet(enemy3.enemy3Tasklet)]
            elif layer == 4:
                enemyTasklets = [ss.tasklet(enemy1.enemy1Tasklet), ss.tasklet(enemy2.enemy2Tasklet), \
                                 ss.tasklet(enemy3.enemy3Tasklet)]

            if layer == 4:
                [t(False) for t in enemyTasklets]
            else:
                [t() for t in enemyTasklets]

            layer = bgChannels.progressionChannel.receive()
    except TaskletExit:
        [t.kill() for t in enemyTasklets]
