import stackless as ss
from PySFML import sf
from settings.settings import *
import globals.globals as g
import channels.channels as channels
from . import channels as bgChannels
import graphics.graphics as graphics
from . import collisions as coll
from .types import *
import time

projectiles = []

def projectilesTasklet():
    global projectiles

    while 1:
        catInfo = bgChannels.catInfoChannel.receive()

        # remove dead projectiles
        projectiles = [p for p in projectiles if not p.isDead()]

        # update projectiles pre-collision
        projInfoReqs = []
        for proj in projectiles:
            projInfoReqs += proj.updatePreColl(catInfo)

        if projInfoReqs == []:
            continue

        # submit collision info/requests
        bgChannels.collisionsChannel.send(projInfoReqs)
        collResponses = bgChannels.collisionResponsesChannel.receive()

        # update projectiles post-collision
        for proj in projectiles:
            proj.updatePostColl(catInfo, collResponses)

        # draw projectiles
        for proj in projectiles:
            proj.draw()

def projectilesAddTasklet():
    while 1:
        proj = bgChannels.projAddChannel.receive()
        projectiles.append(proj)
