import stackless as ss
from PySFML import sf
import graphics.graphics as graphics
import globals.globals as g
import channels.channels as channels
from . import channels as bgChannels
from settings.settings import *

layer = 1

riverSpeed  = 20.0
riverWidth  = 441.0
riverY      = 679.0

numGround       = 5
groundOffsetX   = 0
groundWidth     = 235.0
groundY         = 719.0

grassSpeed  = 0.0
grassWidth  = 224.0
grassY      = 644.0

lotusSpeed      = 10.0
lotusWidth      = 86.0
lotusY          = 664.0
lotusInterval   = lotusWidth * 8

bushSpeed           = 0.0
bushWidth           = 141.0
bushY               = 604.0
bushInterval        = 200.0
greenBushOffsetX    = 81.0

millweedX1   = 50.0
millweedX2   = 900.0
millweedY    = 639.0

sunX = 500.0
sunY = 40.0

def backgroundTasklet():
    global layer
    
    groundImg = sf.Image()
    groundImg.LoadFromFile(dataPath + "backgrounds/pond/pond_ground.png")
    groundSpr = sf.Sprite(groundImg)

    waterImg = sf.Image()
    waterImg.LoadFromFile(dataPath + "backgrounds/pond/pond_water.png")
    waterSpr = sf.Sprite(waterImg)

    grassImg = sf.Image()
    grassImg.LoadFromFile(dataPath + "backgrounds/pond/pond_grass.png")
    grassSpr = sf.Sprite(grassImg)
    grassImg.SetSmooth(False)

    lotusImg = sf.Image()
    lotusImg.LoadFromFile(dataPath + "backgrounds/pond/pond_Lotus.png")
    lotusSpr = sf.Sprite(lotusImg)

    greenBushImg = sf.Image()
    greenBushImg.LoadFromFile(dataPath + "backgrounds/pond/pond_greenBush.png")
    greenBushImg.SetSmooth(False)
    greenBushSpr = sf.Sprite(greenBushImg)

    brownBushImg = sf.Image()
    brownBushImg.LoadFromFile(dataPath + "backgrounds/pond/pond_brownBush.png")
    brownBushImg.SetSmooth(False)
    brownBushSpr = sf.Sprite(brownBushImg)

    millweedImg = sf.Image()
    millweedImg.LoadFromFile(dataPath + "backgrounds/pond/pond_millweed.png")
    millweedSpr = sf.Sprite(millweedImg)

    lotusStart  = 0
    riverStart  = 0
    grassStart  = 0
    bushStart   = 0

    sadSunImg = sf.Image()
    sadSunImg.LoadFromFile(dataPath + "progress/pi-sad.png")
    sadSunSpr = sf.Sprite(sadSunImg)

    indSunImg = sf.Image()
    indSunImg.LoadFromFile(dataPath + "progress/pi-ind.png")
    indSunSpr = sf.Sprite(indSunImg)

    hapSunImg = sf.Image()
    hapSunImg.LoadFromFile(dataPath + "progress/pi-happy.png")
    hapSunSpr = sf.Sprite(hapSunImg)

    sunSpr = [sadSunSpr, indSunSpr, hapSunSpr]

    while 1:
        (layer, value) = bgChannels.backgroundChannel.receive()

        sunSpr[value].SetPosition(sunX, sunY)
        g.window.Draw(sunSpr[value])
        
        # bushes
        if layer >= 3:
            bushStart -= bushSpeed * g.timeDelta
            if bushStart < -bushInterval:
                bushStart += bushInterval
            i = bushStart
            while i <= windowWidth:
                brownBushSpr.SetPosition(i, bushY)
                greenBushSpr.SetPosition(i + greenBushOffsetX, bushY)
                g.window.Draw(greenBushSpr)
                g.window.Draw(brownBushSpr)
                i += bushInterval

        # grass
        if layer >= 2:
            grassStart -= grassSpeed * g.timeDelta
            if grassStart < -grassWidth:
                grassStart += grassWidth
            i = grassStart
            while i <= windowWidth:
                grassSpr.SetPosition(i, grassY)
                g.window.Draw(grassSpr)
                i += grassWidth

        # water

            riverStart -= riverSpeed * g.timeDelta
            if riverStart < -riverWidth:
                riverStart += riverWidth
            i = riverStart
            while i <= windowWidth:
                waterSpr.SetPosition(i, riverY)
                g.window.Draw(waterSpr)
                i += riverWidth

        # lotus
        if layer >= 4:
            lotusStart -= lotusSpeed * g.timeDelta
            if lotusStart < -lotusInterval:
                lotusStart += lotusInterval
            i = lotusStart
            while i <= windowWidth:
                lotusSpr.SetPosition(i, lotusY)
                g.window.Draw(lotusSpr)
                i += lotusInterval

        # ground
        for i in range(numGround):
            groundSpr.SetPosition(groundOffsetX + groundWidth * i, groundY)
            g.window.Draw(groundSpr)

        # milweed
        if layer >= 4:
            millweedSpr.SetPosition(millweedX1, millweedY)
            g.window.Draw(millweedSpr)
            millweedSpr.SetPosition(millweedX2, millweedY)
            g.window.Draw(millweedSpr)
