import stackless as ss
from PySFML import sf
from globals import globals as g
from settings.settings import *
import channels.channels as channels
from main.gameType import *

canniInfoImg = sf.Image()
canniInfoImg.LoadFromFile(dataPath + "info/canni-info.png")
canniInfoSpr = sf.Sprite(canniInfoImg)
canniInfoSpr.SetPosition(0.0, 0.0)

beatInfoImg = sf.Image()
beatInfoImg.LoadFromFile(dataPath + "info/beat-info.png")
beatInfoSpr = sf.Sprite(beatInfoImg)
beatInfoSpr.SetPosition(0.0, 0.0)

blocksInfoImg = sf.Image()
blocksInfoImg.LoadFromFile(dataPath + "info/blocks-info.png")
blocksInfoSpr = sf.Sprite(blocksInfoImg)
blocksInfoSpr.SetPosition(0.0, 0.0)

def drawInfo():
    if g.gameType == GameType.BEAT_GAME:
        g.window.Draw(beatInfoSpr)
    elif g.gameType == GameType.PLATFORMER_GAME:
        g.window.Draw(blocksInfoSpr)
    elif g.gameType == g.GameType.CANNI_GAME:
        g.window.Draw(canniInfoSpr)

def infoTasklet():
    g.escDisabled = True

    while 1:
        eventsList = channels.gameMainChannel.receive()
        channels.inputUpdateChannel.send(eventsList)
        inputState = channels.inputChannel.receive()

        drawInfo()

        if inputState.keyPressed("c") or inputState.joyPressed("jump"):
            g.gameDone = True
            break

        ss.schedule()

    g.escDisabled = False
