import stackless as ss
from PySFML import sf
import sys
from settings.settings import *
import globals.globals as g
import channels.channels as channels
from main.gameType import *

clock = sf.Clock()

def mainTasklet():
    clock.Reset()

    while 1:
        eventsList = []
        event = sf.Event()
        while g.window.GetEvent(event):
            eventsList.append(event)
 
            # window closed
            if event.Type == sf.Event.Closed:
                sys.exit(0)
 
            elif event.Type == sf.Event.KeyPressed:
                # quit key pressed
                if event.Key.Code == sf.Key.Q:
                    sys.exit(0)

            elif event.Type == sf.Event.KeyReleased:
                # esc key pressed
                if event.Key.Code == sf.Key.Escape:
                    if g.gameType != GameType.NO_GAME and not g.escDisabled:
                        return

            # start button pressed
            elif event.Type == sf.Event.JoyButtonReleased:
                if event.JoyButton.Button == 6:
                    if g.gameType != GameType.NO_GAME and not g.escDisabled:
                        return
 
            event = sf.Event()

        g.window.Clear(sf.Color.White)

        channels.gameMainChannel.send(eventsList)

        g.window.Display()
 
        g.timeDelta = clock.GetElapsedTime()
        clock.Reset()

        if g.gameDone:
            g.gameDone = False
            return
