import stackless as ss
from PySFML import sf
import channels.channels as channels
import graphics.graphics as graphics
import globals.globals as g
from main.gameType import *
from settings.settings import *

canniRect = sf.FloatRect(0.0, 300.0, 298.0, 480.0)
beatRect = sf.FloatRect(300.0, 360.0, 540.0, 597.0)
blocksRect = sf.FloatRect(539.0, 240.0, 839.0, 419.0)
creditsRect = sf.FloatRect(0.0, 660.0, 300.0, 720.0)

menuImg = sf.Image()
menuImg.LoadFromFile(dataPath + "menu/mainmenu.jpg")
menuSpr = sf.Sprite(menuImg)
menuSpr.SetPosition(0.0, 0.0)

creditsImg = sf.Image()
creditsImg.LoadFromFile(dataPath + "menu/credits.jpg")
creditsSpr = sf.Sprite(creditsImg)
creditsSpr.SetPosition(0.0, 0.0)

selectColor = sf.Color(0x66, 0xb0, 0xf7)

def translateMousePos(x, y):
    return (x * (windowWidth / g.window.GetWidth()), \
            y * (windowHeight / g.window.GetHeight()))

def drawSelectOverlay1():
    rects = [sf.FloatRect(0, 300, 3, 480),
             sf.FloatRect(0, 300, 300, 303),
             sf.FloatRect(297, 300, 300, 420),
             sf.FloatRect(239, 417, 300, 420),
             sf.FloatRect(239, 417, 242, 480),
             sf.FloatRect(0, 480, 242, 483)
            ]
    [graphics.drawRect(g.window, r, selectColor) for r in rects]

def drawSelectOverlay2():
    rects = [sf.FloatRect(299, 420, 302, 600),
             sf.FloatRect(302, 597, 480, 600),
             sf.FloatRect(477, 540, 480, 597),
             sf.FloatRect(477, 537, 540, 540),
             sf.FloatRect(537, 360, 540.0, 540),
             sf.FloatRect(360, 360, 537, 363),
             sf.FloatRect(360, 360, 363, 420),
             sf.FloatRect(299, 420, 363, 423)
            ]
    [graphics.drawRect(g.window, r, selectColor) for r in rects]

def drawSelectOverlay3():
    rects = [sf.FloatRect(539, 240, 841, 243),
             sf.FloatRect(839, 243, 842, 361),
             sf.FloatRect(779, 358, 842, 361),
             sf.FloatRect(779, 361, 782, 421),
             sf.FloatRect(539, 418, 782, 421),
             sf.FloatRect(539, 240, 542, 421)
            ]
    [graphics.drawRect(g.window, r, selectColor) for r in rects]

def startGame1():
    g.gameType = GameType.CANNI_GAME
    g.gameDone = True

def startGame2():
    g.gameType = GameType.BEAT_GAME
    g.gameDone = True

def startGame3():
    g.gameType = GameType.PLATFORMER_GAME
    g.gameDone = True

def menuTasklet():
    selection = 1
    prevJoyLeft = False
    prevJoyRight = False
    credits = False

    g.gameType = GameType.NO_GAME

    while 1:
        eventsList = channels.gameMainChannel.receive()
        channels.inputUpdateChannel.send(eventsList)
        inputState = channels.inputChannel.receive()

        (mouseX, mouseY) = translateMousePos(inputState.mouseX, inputState.mouseY)

        if credits:
            g.window.Draw(creditsSpr)

            if inputState.keyPressed("esc"):
                credits = False

            # switch to menu
            if creditsRect.Contains(mouseX, mouseY):
                if inputState.mouse0Down and not inputState.prevMouse0Down:
                    credits = False
        else:
            g.window.Draw(menuSpr)

            # joystick
            if selection == 1:
                drawSelectOverlay1()
            elif selection == 2:
                drawSelectOverlay2()
            elif selection == 3:
                drawSelectOverlay3()

            if inputState.joyLeft and not prevJoyLeft:
                if selection >= 2:
                    selection -= 1
            elif inputState.joyRight and not prevJoyRight:
                if selection < 3:
                    selection += 1

            if inputState.joyPressed("jump"):
                print(selection)
                if selection == 1:
                    return startGame1()
                elif selection == 2:
                    return startGame2()
                elif selection == 3:
                    return startGame3()

            # mouse clicks
            if canniRect.Contains(mouseX, mouseY):
                selection = 1
                if inputState.mouse0Down:
                    return startGame1()
            elif beatRect.Contains(mouseX, mouseY):
                selection = 2
                if inputState.mouse0Down:
                    return startGame2()
            elif blocksRect.Contains(mouseX, mouseY):
                selection = 3
                if inputState.mouse0Down:
                    return startGame3()

            # switch to credits
            if creditsRect.Contains(mouseX, mouseY):
                if inputState.mouse0Down and not inputState.prevMouse0Down:
                    credits = True

            prevJoyLeft = inputState.joyLeft
            prevJoyRight = inputState.joyRight

        ss.schedule()
