import stackless as ss
from PySFML import sf
import graphics.graphics as graphics
import globals.globals as g
import channels.channels as channels
from . import channels as bgChannels
from settings.settings import *

layer = 1

#numGround       = 10
#groundOffsetX   = 0.0
#groundWidth     = 104.0
#groundY         = 595.0

#mountainsFgY = 1024.0 - 256.0 * 2

#mountainsBgY = 1024.0 - 256.0 * 2 - 30.0

def backgroundTasklet():
    global layer

    windowWidth = 1023
    windowHeight = 767

    space0Img = sf.Image()
    space0Img.LoadFromFile(dataPath + "backgrounds/space/space0.jpg")
    space0Spr = sf.Sprite(space0Img)
    space0Spr.Resize(windowWidth, windowHeight)

    space1Img = sf.Image()
    space1Img.LoadFromFile(dataPath + "backgrounds/space/space1.jpg")
    space1Spr = sf.Sprite(space1Img)
    space1Spr.Resize(windowWidth, windowHeight)

    space2Img = sf.Image()
    space2Img.LoadFromFile(dataPath + "backgrounds/space/space2.jpg")
    space2Spr = sf.Sprite(space2Img)
    space2Spr.Resize(windowWidth, windowHeight)

    space3Img = sf.Image()
    space3Img.LoadFromFile(dataPath + "backgrounds/space/space3.jpg")
    space3Spr = sf.Sprite(space3Img)
    space3Spr.Resize(windowWidth, windowHeight)

    floorImg = sf.Image()
    floorImg.LoadFromFile(dataPath + "backgrounds/space/spaceGround.png")
    floorSpr = sf.Sprite(floorImg)
    floorSpr.SetPosition(0.0, 700.0)
    floorSpr.Resize(windowWidth, floorImg.GetHeight())

    while 1:
        bgChannels.backgroundChannel.receive()

        if layer == 0:
            space0Spr.SetPosition(0.0, 0.0)
            g.window.Draw(space0Spr)

        # background
        if layer == 1:
            space1Spr.SetPosition(0.0, 0.0)
            g.window.Draw(space1Spr)
        # mountains (background)
        if layer == 2:
            space2Spr.SetPosition(0.0, 0.0)
            g.window.Draw(space2Spr)
        # mountains (foreground)
        if layer == 3:
            space3Spr.SetPosition(0.0, 0.0)
            g.window.Draw(space3Spr)

        g.window.Draw(floorSpr)

def backgroundUpdateTasklet():
    global layer

    while 1:
        (layer, prog) = bgChannels.levelChannel.receive()
        #print("layer: " + str(layer))
