import stackless as ss
from PySFML import sf
import graphics.graphics as graphics
import globals.globals as g
from . import collisions as coll
import channels.channels as channels
from . import channels as bgChannels
from settings.settings import *

floorX = 0.0
floorY = 700.0
floorWidth = 1024.0
floorHeight = 768.0

leftWallX = -1000.0
leftWallY = 0.0
leftWallWidth = 1000.0
leftWallHeight = windowHeight + 1000

rightWallX = 1024.0
rightWallY = 0.0
rightWallWidth = rightWallX + 50.0
rightWallHeight = windowHeight

floorRect = None
leftWallRect = None
rightWallRect = None

def worldInit():
    global floorRect, leftWallRect, rightWallRect

    floorRect = sf.FloatRect(floorX, floorY, floorWidth, floorHeight)
    leftWallRect = sf.FloatRect(leftWallX, leftWallY, leftWallX + leftWallWidth, leftWallHeight)
    rightWallRect = sf.FloatRect(rightWallX, rightWallY, rightWallWidth, rightWallHeight)

def worldTasklet():
    global floorRect, leftWallRect, rightWallRect

    worldInit()

    while 1:
        bgChannels.worldChannel.receive()
        #graphics.drawRect(g.window, floorRect, sf.Color.Black)
        graphics.drawRect(g.window, leftWallRect, sf.Color.Black)
        graphics.drawRect(g.window, rightWallRect, sf.Color.Black)

        bgChannels.collisionsChannel.send([coll.CollisionInfo("floor", floorRect, None),
                                           coll.CollisionInfo("leftwall", leftWallRect, None),
                                           coll.CollisionInfo("rightwall", rightWallRect, None)])
