import stackless as ss
from PySFML import sf
import main.main as main
from main.gameType import *
import music.music as music
from settings.settings import *
import input.input as input
from globals import globals as g
import menu.menu as menu
import info.infoTasklet as info
import victory.victory as victory
from beatGame import tasklets as beatGame
from platformer import tasklets as platformerGame
from cannibalGame import tasklets as cannibalGame
from shooterGame import tasklets as shooterGame

gameTasklets = []

# create window
g.window = sf.RenderWindow(sf.VideoMode(windowWidth, windowHeight), "Mochicat")
g.window.UseVerticalSync(useVsync)

# start general program tasklets
ss.tasklet(input.inputUpdateTasklet)()

def runMenu():
    ss.tasklet(main.mainTasklet)()
    ss.tasklet(menu.menuTasklet)()
    ss.run()

def runGame():
    global gameTasklets

    ss.tasklet(main.mainTasklet)()

    if g.gameType == GameType.BEAT_GAME:
        gameTasklets = beatGame.createTasklets()
    elif g.gameType == GameType.PLATFORMER_GAME:
        gameTasklets = platformerGame.createTasklets()
    elif g.gameType == g.GameType.CANNI_GAME:
        gameTasklets = cannibalGame.createTasklets()
    elif g.gameType == g.GameType.SHOOTER_GAME:
    	gameTasklets = shooterGame.createTasklets()

    for t in gameTasklets:
        t()

    ss.run()

def runGameInfo():
    ss.tasklet(main.mainTasklet)()
    ss.tasklet(info.infoTasklet)()

    ss.run()

def runVictoryScreen():
    ss.tasklet(main.mainTasklet)()
    ss.tasklet(victory.victoryTasklet)()

    ss.run()

def killGame():
    global gameTasklets

    for t in gameTasklets:
        t.kill()

# main loop
while 1:
    runMenu()

    runGameInfo()

    runGame()

    killGame()

    if g.gameWon:
        runVictoryScreen()
