import stackless as ss
from PySFML import sf
import channels.channels as channels
from . import channels as bgChannels
import graphics.graphics as graphics

from math import sqrt
import sys
from settings.settings import *
import globals.globals as g
from .types import *
import time

class Mover:
  R     = 0
  DR    = 1
  D     = 2
  DL    = 3
  L     = 4
  UL    = 5
  U     = 6
  UR    = 7
  STAY  = 8

class Shoot:
  N = 0
  S = 1
  
class Invincible:
  NOT = 0
  INV = 1

catStartX   = 20.0
catStartY   = windowHeight/2

class Cat:
  def __init__(self,sprX,sprY):
    self.startX = sprX
    self.startY = sprY
    self.clk = sf.Clock()
    self.thresh = 0.2
  
    self.sprX = sprX
    self.sprY = sprY
    self.mover = Mover.STAY
    self.shoot = Shoot.N
    self.shotCnt = 0
    self.invincible = Invincible.NOT
    self.invClk = sf.Clock()
    self.invThresh = 1
    self.invSwitch = 0
    
    mochicatImg = sf.Image()
    mochicatImg.LoadFromFile(dataPath + "cats/mochicat0.png")
    self.mochicatSpr = sf.Sprite(mochicatImg)
    
    self.sizX = self.mochicatSpr.GetSize()[0]
    self.sizY = self.mochicatSpr.GetSize()[1]
    
    mochicatImg1 = sf.Image()
    mochicatImg1.LoadFromFile(dataPath + "cats/mochicatBaby.png")
    mochicatShot1 = sf.Sprite(mochicatImg1)
    mochicatShot2 = sf.Sprite(mochicatImg1)
    mochicatShot3 = sf.Sprite(mochicatImg1)
    self.freeShot = []
    self.freeShot.append(mochicatShot1)
    self.freeShot.append(mochicatShot2)
    self.freeShot.append(mochicatShot3)
    self.shots = []
    self.shotCnt = 0;
    
  def draw(self):                 
    bgChannels.returnChannel.send(self)  
    enemy = bgChannels.enemiesChannel.receive()   
    #bgChannels.bgChannel.send(self)


  
    self.mochicatSpr.SetPosition(self.sprX, self.sprY)
    
    if self.mover == Mover.U:
        x = 0
        y = 5
    elif self.mover == Mover.D:
        x = 0
        y = -5
    elif self.mover == Mover.L:
        x = -5
        y = 0
    elif self.mover == Mover.R:
        x = 5
        y = 0
    elif self.mover == Mover.UL:
        x = -5/sqrt(2)
        y = 5/sqrt(2)
    elif self.mover == Mover.UR:
        x = 5/sqrt(2)
        y = 5/sqrt(2)
    elif self.mover == Mover.DL:
        x = -5/sqrt(2)
        y = -5/sqrt(2)
    elif self.mover == Mover.DR:
        x = 5/sqrt(2)
        y = -5/sqrt(2)
    else:
        x = 0
        y = 0
    
    self.mochicatSpr.Move(x,-y)
    
    self.sprX = self.mochicatSpr.GetPosition()[0]
    self.sprY = self.mochicatSpr.GetPosition()[1]

    if self.sprX < 0:
      self.mochicatSpr.SetX(0)
    if self.sprX + self.sizX > windowWidth:
      self.mochicatSpr.SetX(windowWidth-self.sizX)
    if self.sprY < 0:
      self.mochicatSpr.SetY(0)
    if self.sprY + self.sizY > windowHeight:
      self.mochicatSpr.SetY(windowHeight-self.sizY)
      
    self.sprX = self.mochicatSpr.GetPosition()[0]
    self.sprY = self.mochicatSpr.GetPosition()[1]

    #g.window.Draw(self.bgSpr)
    if(self.invincible == Invincible.INV and self.invSwitch == 0):
      self.invSwitch = 1
    else:
      self.invSwitch = 0
      g.window.Draw(self.mochicatSpr)
      
    if self.invincible:
      if self.invClk.GetElapsedTime() > self.invThresh:
        self.invincible = Invincible.NOT
    
    if self.shoot == Shoot.S:
      if self.clk.GetElapsedTime() > self.thresh:
          self.clk.Reset()
          self.shoot = Shoot.N
          if self.shotCnt < 3:
            self.shotCnt += 1
            self.shots.append(self.freeShot[3-self.shotCnt])
            self.freeShot.pop(3-self.shotCnt)
            self.shots[self.shotCnt-1].SetPosition(self.sprX + self.sizX - 9, self.sprY + int(float(self.sizY)/2))

    for i in range(0,self.shotCnt):
      self.shots[i].Move(12,0)

    if self.shotCnt >= 1:
        if self.shots[0].GetPosition()[0] > windowWidth:
                self.freeShot.append(self.shots[0])
                self.shots.pop(0)
                self.shotCnt -= 1
        else:
                g.window.Draw(self.shots[0])

    for j in range(0,len(enemy)):
        for i in range(0,self.shotCnt):
          if self.shots[i].GetPosition()[0] + self.shots[i].GetSize()[0] <= enemy[j].spr.GetPosition()[0] + enemy[j].spr.GetSize()[0] and self.shots[i].GetPosition()[0] + self.shots[i].GetSize()[0] >= enemy[j].spr.GetPosition()[0] and self.shots[i].GetPosition()[1] + self.shots[i].GetSize()[1]/2 <= enemy[j].spr.GetPosition()[1] + enemy[j].spr.GetSize()[1] and self.shots[i].GetPosition()[1] + self.shots[i].GetSize()[1]/2 >= enemy[j].spr.GetPosition()[1]:
            self.freeShot.append(self.shots[i])
            self.shots.pop(i)
            self.shotCnt -= 1
            enemy[j].destroyed = 1
            break
            
    for j in range(0,len(enemy)):
        if enemy[j].spr.GetPosition()[0] + (enemy[j].spr.GetSize()[0]/2) <= self.sprX + self.sizX and enemy[j].spr.GetPosition()[0] + (enemy[j].spr.GetSize()[0]/2) >= self.sprX and enemy[j].spr.GetPosition()[1] + (enemy[j].spr.GetSize()[1]/2) <= self.sprY + self.sizY and enemy[j].spr.GetPosition()[1] + (enemy[j].spr.GetSize()[1]/2) >= self.sprY and self.invincible == Invincible.NOT:
          self.sprX = self.startX
          self.sprY = self.startY
          self.invincible = Invincible.INV
          self.invClk.Reset()
    
        for i in range(0,len(enemy[j].shots)):
          if enemy[j].shots[i].spr.GetPosition()[0] <= self.sprX + self.sizX and enemy[j].shots[i].spr.GetPosition()[0] >= self.sprX and enemy[j].shots[i].spr.GetPosition()[1] + (enemy[j].shots[i].spr.GetSize()[1]/2) <= self.sprY + self.sizX and enemy[j].shots[i].spr.GetPosition()[1] + (enemy[j].shots[i].spr.GetSize()[1]/2) >= self.sprY and self.invincible == Invincible.NOT:
            self.sprX = self.startX
            self.sprY = self.startY
            self.invincible = Invincible.INV
            self.invClk.Reset()
            
            


#    if not destroyed:
#      window.Draw(enemy)

    if self.shotCnt == 3:
      g.window.Draw(self.shots[2])
    if self.shotCnt >= 2:
      g.window.Draw(self.shots[1])

  def update(self,inputState):
    #Can't do arrow keys b/c of ghosting
    #Can't do up left and space at the same time
    l = inputState.keyDown("a")
    r = inputState.keyDown("d")
    u = inputState.keyDown("w")
    d = inputState.keyDown("s")

    s = inputState.keyDown("space")

    if u and l:
      self.mover = Mover.UL
    elif d and l:
      self.mover = Mover.DL
    elif l:
      self.mover = Mover.L
    elif u and r:
      self.mover = Mover.UR
    elif d and r:
      self.mover = Mover.DR
    elif r:
      self.mover = Mover.R
    elif d:
      self.mover = Mover.D
    elif u:
      self.mover = Mover.U
    else:
      self.mover = Mover.STAY

    if s:
      self.shoot = Shoot.S
    else:
      self.shoot = Shoot.N          
   
  def info(self):
    return CatInfo(self.sprX, self.sprY)
    
    
def catTasklet():
    cat = Cat(catStartX, catStartY)

    while 1:
        inputState = channels.inputChannel.receive()
        
        cat.update(inputState)
        cat.draw()

